package com.malk.kabeiyi;

import com.alibaba.fastjson.JSONObject;
import com.malk.kabeiyi.service.KabeiyiService;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.service.aliwork.YDClient;
import com.malk.service.dingtalk.DDClient;
import com.malk.service.dingtalk.DDClient_Workflow;
import com.malk.utils.UtilDateTime;
import com.malk.utils.UtilMap;
import lombok.extern.slf4j.Slf4j;
import org.apache.logging.log4j.util.Strings;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.slf4j.MDC;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.time.LocalDateTime;
import java.util.*;

@Slf4j
@SpringBootTest
@RunWith(SpringRunner.class)
public class DdTest {


    @Autowired
    private DDClient ddClient;

    @Autowired
    private DDClient_Workflow ddClient_workflow;

    @Autowired
    private KabeiyiService kabeiyiService;

    @Autowired
    private YDClient ydClient;


    @Test
    public void test(){
        LocalDateTime now=LocalDateTime.now();
        Map data=new HashMap();
        data.put("maxResults",10);
        data.put("nextToken",0);
        data.put("statuses", Arrays.asList("COMPLETED"));
        String processCode = "PROC-34A203FD-7EDC-45ED-B081-820250801B44";//1.1、工厂用章流程(除采购营销人事)
//        String processCode = "PROC-AD06D122-828A-40A5-8EDC-94BB246B59D2";

        Map rsp=ddClient_workflow.getInstanceIds(ddClient.getAccessToken(),processCode,
                UtilDateTime.getLocalDateTimeTimeStamp(now.minusDays(120)),UtilDateTime.getLocalDateTimeTimeStamp(now),data);
        List<String> list=(List)rsp.get("list");
        List result=new ArrayList();
        for(String id:list){
            result.add(ddClient_workflow.getProcessInstanceId(ddClient.getAccessToken(),id));
        }
        log.info("result:{}",result);
    }


    @Test
    public void test2(){
        Map map = new HashMap<>();
        map.put("procInstId","gl7nXvi4TLebPjFW2oqmrA05771720664838");
        kabeiyiService.pushProcInstToYD(map);

    }

    @Test
    public void test3(){
        kabeiyiService.testInnerTable();
    }

    @Test
    public void test4(){
        //分层审核
        MDC.put("MDC_KEY_PID","1009");

        List<Map> dataList = (List<Map>) ydClient.queryData(YDParam.builder()
                .formUuid("FORM-89F515967FF94C62A9031F28EF6000B1YV5Q")//问题清单
                .pageNumber(3)
                .pageSize(100)
                .build(), YDConf.FORM_QUERY.retrieve_list).getData();

        for (Map data : dataList) {
            String formInstanceId = UtilMap.getString(data, "formInstanceId");

            Map formData = (Map) data.get("formData");

            String status = UtilMap.getString(formData, "selectField_m0d9pkzx");//整改状态

            if (Strings.isNotBlank(status)){
                Long deadLine = (Long) formData.get("dateField_m061zyev");

                Long date = (Long) formData.get("dateField_m0dbp77k");

                Map updateFormDate = new HashMap();

                if (Objects.isNull(date)){
                    updateFormDate.put("selectField_m0d9pkzx","已超期");
                }else {
                    if (date <= deadLine && !"未超期".equals(status)){
                        updateFormDate.put("selectField_m0d9pkzx","未超期");
                    }
                    if (date > deadLine && !"已超期".equals(status)){
                        updateFormDate.put("selectField_m0d9pkzx","已超期");
                    }
                }

                if (!updateFormDate.keySet().isEmpty()){
                    ydClient.operateData(YDParam.builder()
                            .formInstId(formInstanceId)
                            .updateFormDataJson(JSONObject.toJSONString(updateFormDate))
                            .build(), YDConf.FORM_OPERATION.update);
                }

            }
        }
    }

    @Test
    public void test5(){
        //分层审核
        MDC.put("MDC_KEY_PID","1009");

        List<Map> dataList = (List<Map>) ydClient.queryData(YDParam.builder()
                .formUuid("FORM-F4ED246EADD8427381BC13C4F0FEF7FDYMKJ")//审核任务
                .pageNumber(1)
                .pageSize(100)
                .build(), YDConf.FORM_QUERY.retrieve_list).getData();

        for (Map data : dataList) {
            String formInstanceId = UtilMap.getString(data, "formInstanceId");

            Map formData = (Map) data.get("formData");

            String status = UtilMap.getString(formData, "selectField_m0dbmfxd");//审核状态

            if (Strings.isNotBlank(status)){
                Long deadLine = (Long) formData.get("dateField_m061zye7");

                Long date = (Long) formData.get("dateField_m1hod4tv");

                Map updateFormDate = new HashMap();

                if (Objects.isNull(date)){
                    updateFormDate.put("selectField_m0dbmfxd","已超期");
                }else {
                    if (date <= deadLine && !"未超期".equals(status)){
                        updateFormDate.put("selectField_m0dbmfxd","未超期");
                    }
                    if (date > deadLine && !"已超期".equals(status)){
                        updateFormDate.put("selectField_m0dbmfxd","已超期");
                    }
                }

                if (!updateFormDate.keySet().isEmpty()){
                    ydClient.operateData(YDParam.builder()
                            .formInstId(formInstanceId)
                            .updateFormDataJson(JSONObject.toJSONString(updateFormDate))
                            .build(), YDConf.FORM_OPERATION.update);
                }

            }
        }
    }
}
